<template>
  <div class="component-container">
    <lenna-modal ref="lennaModal"></lenna-modal>
    <!-- <lenna-loading v-show="isLoading"></lenna-loading> -->
    <div>
      <h3 class="text-primary">Integrate with Facebook Messenger</h3>
      <hr>

      <form @submit.prevent>
        <div class="form-group">
          <span class>Login to your Facebook account and select a page you want to integrate.</span>
        </div>

        <div class="form-group row">
          <div class="col-sm-10">
            <v-facebook-login
              v-model="facebook.status"
              :app-id="facebook.FB_APP_ID"
              :login-options="facebook.loginOptions"
              @sdk-init="handleSdkInit"
              @connect="handleConnect"
              @logout="handleLogout"
              @click="handleClick"
              :button-style="facebook.buttonStyle"
            ></v-facebook-login>
          </div>
        </div>
        <br>
        <div class="form-group row">
          <div class="col-sm-10">
            <select name="facebook-page" id class="form-control" v-model="form.pageId">
              <template v-if="connected || form.status">
                <!-- <option value="0">Select your page</option> -->
                <option
                  :value="page.id"
                  v-for="(page,key) in form.pageList"
                  :key="key"
                >{{page.name}}</option>
              </template>
            </select>
          </div>
        </div>
        <div class="form-group row">
          <input type="hidden" v-model="form.status">
          <div class="col-sm-6">
            <button
              type="button"
              class="btn btn-rounded btn-block"
              :class="(!form.status) ? 'btn-secondary': 'btn-danger'"
              :disabled="!form.status"
              @click="disconnectChannel"
            >Disconnect</button>
          </div>
          <div class="col-sm-6">
            <button
              type="button"
              class="btn btn-rounded btn-block btn-primary"
              @click.prevent="submitForm"
            >{{(form.status) ? 'Update': 'Connect'}}</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>
<script>
import VFacebookLogin from "vue-facebook-login-component";

import EventBus from "@/EventBus.js";
export default {
  data() {
    return {
      facebook: {
        FB_APP_ID: process.env.MIX_FB_APP_ID,
        FB: {},
        loginOptions: {
          scope:
            "public_profile,email,manage_pages,pages_messaging,pages_show_list"
        },
        data: null,
        status: {},
        buttonStyle: {
          "border-radius": "100px"
        }
      },
      form: {
        userAccessToken: null,
        pageList: null,
        pageAccessToken: null,
        pageId: null,
        status: false,
        channelName: "facebook"
      }
    };
  },
  components: {
    VFacebookLogin
  },
  computed: {
    // connectedPage(){
    //   let page = _.find(this.form.pageList, (o) => { return o.id == this.form.pageId; });
    //   return page.name || 'No connected page'
    // },
    pageId() {
      return this.form.pageId;
    },
    connected() {
      return this.facebook.status.connected;
    },
    disconnected() {
      return !this.connected;
    }
  },
  methods: {
    async getLongLivedUserToken() {
      let response = await axios.get(
        this.baseUrl + "/api/integration/facebook/get-longlived-token",
        {
          params: {
            userAccessToken: this.facebook.data.authResponse.accessToken
          }
        }
      );
      this.form.userAccessToken = response.data.access_token;
    },
    async getUserPages() {
      // get pages
      let responsePages = await this.$axios.get(
        "https://graph.facebook.com/v3.2/me/accounts",
        {
          params: {
            access_token: this.form.userAccessToken
          }
        }
      );
      this.form.pageList = responsePages.data.data;
      this.form.pageAccessToken = this.form.pageList[0].access_token;
      this.form.pageId = this.form.pageList[0].id;
    },
    checkLoginStatus() {
      this.facebook.FB.getLoginStatus(response => {
        this.facebook.data = response;
      });
    },
    handleSdkInit({ FB }) {
      this.facebook.FB = FB;
    },
    async handleConnect() {
      await this.checkLoginStatus();
      await this.getLongLivedUserToken();
      await this.getUserPages();
    },
    handleLogout() {
      console.info("[V-Facebook-Login info]: Logged `logout` event.");
    },
    handleClick() {
      console.info("[V-Facebook-Login info]: Logged `click` event.");
    },
    async disconnectChannel() {
      try {
        let data = {
          channelName: this.form.channelName,
          status: false
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.$refs.lennaModal.show("info", "Success", response.message);

        this.form.status = false;
        EventBus.$emit("toggleStatusMain", "facebook");
      } catch (error) {
        this.form.status = !this.form.status;
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          let formData = {
            ...this.form,
            status: true
          };
          let response = await this.$axios.post(
            `api/${this.$store.getters.appId.hashed}/integrate`,
            formData
          );
          this.form.status = true;
          this.$refs.lennaModal.show("info", "Success", response.data.message);

          EventBus.$emit("toggleStatusMain", "facebook");
        } catch (error) {
          this.$refs.lennaModal.show(
            "alert",
            "Sorry",
            error.response.data.message
          );
        }
      } else {
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          "You must correct your form first"
        );
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      let channelData = response.data.find(function(item) {
        return item.name == "facebook";
      }).integration;

      if (channelData != null) {
        this.form.pageList = channelData.integration_data.pageList;
        this.form.pageId = channelData.integration_data.pageId;
        this.form.pageAccessToken =
          channelData.integration_data.pageAccessToken;
        this.form.userAccessToken =
          channelData.integration_data.userAccessToken;
        this.form.status = channelData.status;
      }
    }
  },
  mounted() {
    if (this.disconnected) {
      this.fetchData();
    }

    EventBus.$on("toggleStatus", value => {
      this.fetchData();
    });
  },
  watch: {
    pageId() {
      let page = _.find(this.form.pageList, obj => {
        return obj.id == this.pageId;
      });
      this.form.pageAccessToken = page.access_token;
    }
  }
};
</script>
<style lang="scss">
.component-container {
  position: relative;
}
</style>
